/*
 *  Clovece, nezlob se!
 *  (c)2001 by Jan Krupa(krupaj@mobilnews.cz)
 */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <graphics.h>

// Path to the EGAVGA.BGI(this value should be changed)
#define GR_PATH ""

// Debug mode(it should be set to 0 for normal game)
// set to 1 for some "extra" features ;-)
#define DEBUG 0

#define MAX_FIELDS 50
#define MAX_PLAYERS 4
#define P_FIG 4

// Radius of all playing fields(default==15)
#define FIELD_RADIUS 15

struct PL_FIELD {
				  char name[20]; // not used, yet :)
				  int n; // actual number of fields
				  int x[MAX_FIELDS]; // x fields position
				  int y[MAX_FIELDS]; // y fields position

				  int fn[MAX_PLAYERS]; // field - nasazovani
				  int fh[MAX_PLAYERS]; // field - cesta do domku

				  int nx[MAX_PLAYERS][P_FIG]; // nasazovani
				  int ny[MAX_PLAYERS][P_FIG];
				  int dx[MAX_PLAYERS][P_FIG]; // domecek
				  int dy[MAX_PLAYERS][P_FIG];
				} f;

struct PL_INFO {
				 char name[20];
				 int c; // player color
				 int f[P_FIG]; // umisteni figurek na hracim poli
			   } pl[MAX_PLAYERS];

int gd=DETECT, gm, errcode;

int apl=0,afig=0, kostka=3; // active pl, figurka, hod kostkou

// *************************************************************************
void draw_afig_gr(int x1, int y1, int v1)
// x1 ... x position of the figurka
// y1 ... y position of the figurka
// v1 ... visible
{
  if (v1) setcolor (11);
     else setcolor (8);
  circle(x1,y1,(FIELD_RADIUS+2));
  circle(x1,y1,(FIELD_RADIUS+3));
}

void draw_figurka_gr(int x1, int y1, int c1)
// x1 ... x position of the figurka
// y1 ... y position of the figurka
// c1 ... figurka color
{
  setcolor(0);
  setfillstyle(1,c1);
  fillellipse(x1,(y1-6),(FIELD_RADIUS-11),(FIELD_RADIUS-11));
  fillellipse(x1,(y1+4),(FIELD_RADIUS-9),(FIELD_RADIUS-9));
}

void draw_field_gr(int x1, int y1, int c1, int f1)
// x1 ... x position of the field
// y1 ... y position of the field
// c1 ... field color
// f1 ... figurka - if not (-1)
// a1 ... active - 1==true, 0==false
{
  setcolor(15);
  setfillstyle(1,c1);
  fillellipse(x1,y1,FIELD_RADIUS,FIELD_RADIUS);

  if (f1!=(-1))
  {
	draw_figurka_gr(x1,y1,f1);
  }

  draw_afig_gr(x1,y1,0);
}

void draw_field(int p1, int s1)
// p1 ... field position
// s1 ... special field (-1)==false, other==player_number
// c1 ... clear
{
  int ix1,ix2;

  if (s1==(-1))
  {
	ix2=(-1);
	for (ix1=0; ix1<MAX_PLAYERS; ix1++)
	{
	  if (f.fn[ix1]==p1)
	  {
		draw_field_gr(f.x[p1],f.y[p1],pl[ix1].c,(-1));
		ix2=ix1;
	  }
	}
	if (ix2==(-1))
	{
	  draw_field_gr(f.x[p1],f.y[p1],7,(-1));
	}
  }
  else
  {
	if (p1<4)
	{
	  draw_field_gr(f.nx[s1][p1],f.ny[s1][p1],pl[s1].c,(-1));
	}
	else
	{
	  draw_field_gr(f.dx[s1][(p1-4)],f.dy[s1][(p1-4)],pl[s1].c,(-1));
	}
  }

  for (ix1=0; ix1<MAX_PLAYERS; ix1++)
  {
	for (ix2=0; ix2<P_FIG; ix2++)
	{
	  // figurka is on the normal playing filelds
	  if ( (pl[ix1].f[ix2]<f.n)
		&& (s1==(-1))
		&& (pl[ix1].f[ix2]==p1) )
	  {
		draw_figurka_gr(f.x[p1],f.y[p1],pl[ix1].c);

		if ( (apl==ix1) && (afig==ix2) ) { draw_afig_gr(f.x[p1],f.y[p1],1); }
									else { draw_afig_gr(f.x[p1],f.y[p1],0); }
	  }

	  // figurka is in (domecek || nasazovani)
	  if ( (pl[ix1].f[ix2]>=f.n)
		 && (s1==ix1) )
	  {
		// figurka is in nasazovani
		if ( (pl[ix1].f[ix2]<(f.n+4))
		  && ((pl[ix1].f[ix2]-f.n)==p1) )
		{
		  draw_figurka_gr(f.nx[ix1][p1],f.ny[ix1][p1],pl[ix1].c);
		  if ( (apl==ix1) && (afig==ix2) ) { draw_afig_gr(f.nx[ix1][p1],f.ny[ix1][p1],1); }
									  else { draw_afig_gr(f.nx[ix1][p1],f.ny[ix1][p1],0); }
		}

		// figurka is in domecek
		if ( (pl[ix1].f[ix2]>=(f.n+4))
		  && ((pl[ix1].f[ix2]-f.n)==p1) )
		{
		  draw_figurka_gr(f.dx[ix1][(p1-4)],f.dy[ix1][(p1-4)],pl[ix1].c);
		  if ( (apl==ix1) && (afig==ix2) ) { draw_afig_gr(f.dx[ix1][(p1-4)],f.dy[ix1][(p1-4)],1); }
									  else { draw_afig_gr(f.dx[ix1][(p1-4)],f.dy[ix1][(p1-4)],0); }
		}

	  }
	}
  }
}

void draw_field2(int p1, int s1)
// p1 ... field position
// s1 ... special field (-1)==false, other==player_number
{
  int ix1;

  ix1=p1;
  if (ix1>=f.n) ix1=ix1-f.n;
	   else s1=(-1);

  draw_field(ix1,s1);
}


void redraw_field()
// redraw playing field
{
  int ix1,ix2;

  setfillstyle(1,8);
  bar(0,0,getmaxx(),getmaxy());

  setcolor(0); outtextxy (11,11,"Clovece, nezlob se!");
  setcolor(15); outtextxy (10,10,"Clovece, nezlob se!");
  setcolor(0); outtextxy (11,22,"(c)2001 by Jan Krupa.");
  setcolor(15); outtextxy (10,21,"(c)2001 by Jan Krupa.");

  setcolor(0); outtextxy (26,76,"Skip turn");
  setcolor(15); outtextxy (25,75,"Skip turn");

  for (ix1=0; ix1<f.n; ix1++)
  {
	draw_field(ix1,(-1));
  }

  for (ix2=0; ix2<MAX_PLAYERS; ix2++)
  {
	for (ix1=0; ix1<P_FIG; ix1++)
	{
	  draw_field(ix1,ix2);
	  draw_field((ix1+4),ix2);
	}
  }
}

// *************************************************************************
void load_pl_field()
// load playing field(it should be from some file ... in the future ;-)
{
  strcpy(f.name,"STANDARD_FIELD");

  // upper right
  f.x[0]=360; f.y[0]=20; // nasazuje pl1
  f.x[1]=360; f.y[1]=60;
  f.x[2]=360; f.y[2]=100;
  f.x[3]=360; f.y[3]=140;
  f.x[4]=360; f.y[4]=180;

  f.x[5]=400; f.y[5]=180;
  f.x[6]=440; f.y[6]=180;
  f.x[7]=480; f.y[7]=180;
  f.x[8]=520; f.y[8]=180;

  f.x[9]=520; f.y[9]=220;
  f.x[10]=520; f.y[10]=260; // nasazuje pl2

  f.x[11]=480; f.y[11]=260;
  f.x[12]=440; f.y[12]=260;
  f.x[13]=400; f.y[13]=260;
  f.x[14]=360; f.y[14]=260;

  f.x[15]=360; f.y[15]=300;
  f.x[16]=360; f.y[16]=340;
  f.x[17]=360; f.y[17]=380;
  f.x[18]=360; f.y[18]=420;

  f.x[19]=320; f.y[19]=420;
  f.x[20]=280; f.y[20]=420; // nasazuje pl3
  // ^- ivert of start ...

  f.x[21]=280; f.y[21]=380;
  f.x[22]=280; f.y[22]=340;
  f.x[23]=280; f.y[23]=300;
  f.x[24]=280; f.y[24]=260;

  f.x[25]=240; f.y[25]=260;
  f.x[26]=200; f.y[26]=260;
  f.x[27]=160; f.y[27]=260;
  f.x[28]=120; f.y[28]=260;

  f.x[29]=120; f.y[29]=220;
  f.x[30]=120; f.y[30]=180; // nasazuje pl4

  f.x[31]=160; f.y[31]=180;
  f.x[32]=200; f.y[32]=180;
  f.x[33]=240; f.y[33]=180;
  f.x[34]=280; f.y[34]=180;

  f.x[35]=280; f.y[35]=140;
  f.x[36]=280; f.y[36]=100;
  f.x[37]=280; f.y[37]=60;
  f.x[38]=280; f.y[38]=20;

  f.x[39]=320; f.y[39]=20;

  f.n=40;

  // -----------------------------------------------------------------------

  f.fn[0]=0;
  f.fh[0]=39;
  f.nx[0][0]=440; f.ny[0][0]=60;
  f.nx[0][1]=480; f.ny[0][1]=60;
  f.nx[0][2]=440; f.ny[0][2]=100;
  f.nx[0][3]=480; f.ny[0][3]=100;
  f.dx[0][0]=320; f.dy[0][0]=60;
  f.dx[0][1]=320; f.dy[0][1]=100;
  f.dx[0][2]=320; f.dy[0][2]=140;
  f.dx[0][3]=320; f.dy[0][3]=180;

  f.fn[1]=10;
  f.fh[1]=9;
  f.nx[1][0]=480; f.ny[1][0]=340;
  f.nx[1][1]=440; f.ny[1][1]=340;
  f.nx[1][2]=480; f.ny[1][2]=380;
  f.nx[1][3]=440; f.ny[1][3]=380;
  f.dx[1][0]=480; f.dy[1][0]=220; // 360
  f.dx[1][1]=440; f.dy[1][1]=220; // 400
  f.dx[1][2]=400; f.dy[1][2]=220; // 440
  f.dx[1][3]=360; f.dy[1][3]=220; // 480

  f.fn[2]=20;
  f.fh[2]=19;
  f.nx[2][0]=200; f.ny[2][0]=380;
  f.nx[2][1]=160; f.ny[2][1]=380;
  f.nx[2][2]=200; f.ny[2][2]=340;
  f.nx[2][3]=160; f.ny[2][3]=340;
  f.dx[2][0]=320; f.dy[2][0]=380;
  f.dx[2][1]=320; f.dy[2][1]=340;
  f.dx[2][2]=320; f.dy[2][2]=300;
  f.dx[2][3]=320; f.dy[2][3]=260;

  f.fn[3]=30;
  f.fh[3]=29;
  f.nx[3][0]=160; f.ny[3][0]=100;
  f.nx[3][1]=200; f.ny[3][1]=100;
  f.nx[3][2]=160; f.ny[3][2]=60;
  f.nx[3][3]=200; f.ny[3][3]=60;
  f.dx[3][0]=160; f.dy[3][0]=220;
  f.dx[3][1]=200; f.dy[3][1]=220;
  f.dx[3][2]=240; f.dy[3][2]=220;
  f.dx[3][3]=280; f.dy[3][3]=220;
}

void init_players()
// place all players on the playing field
{
  // -- Player1 - start ----------------------------------------------------
  strcpy(pl[0].name,"Player1");
  pl[0].c=1;

  pl[0].f[0]=f.n;
  pl[0].f[1]=f.n+1;
  pl[0].f[2]=f.n+2;
  pl[0].f[3]=f.n+3;
  // -- Player1 - end ------------------------------------------------------

  // -- Player2 - start ----------------------------------------------------
  strcpy(pl[1].name,"Player2");
  pl[1].c=13;

  pl[1].f[0]=f.n;
  pl[1].f[1]=f.n+1;
  pl[1].f[2]=f.n+2;
  pl[1].f[3]=f.n+3;
  // -- Player2 - end ------------------------------------------------------

  // -- Player3 - start ----------------------------------------------------
  strcpy(pl[2].name,"Player3");
  pl[2].c=11;

  pl[2].f[0]=f.n;
  pl[2].f[1]=f.n+1;
  pl[2].f[2]=f.n+2;
  pl[2].f[3]=f.n+3;
  // -- Player3 - end ------------------------------------------------------

  // -- Player4 - start ----------------------------------------------------
  strcpy(pl[3].name,"Player4");
  pl[3].c=14;

  pl[3].f[0]=f.n;
  pl[3].f[1]=f.n+1;
  pl[3].f[2]=f.n+2;
  pl[3].f[3]=f.n+3;
  // -- Player4 - end ------------------------------------------------------
}

// *************************************************************************
void outtextxy_shd(int x1, int y1, int colx, char napisx[])
{
  setcolor (0); outtextxy((x1+1),(y1+1),napisx);
  setcolor (colx); outtextxy(x1,y1,napisx);
}

void outtextxy_bold(int x1, int y1, char napisx[])
{
  outtextxy(x1,y1,napisx);
  outtextxy((x1+1),y1,napisx);
}

void ramecek(int x1, int y1, int x2, int y2, int actx)
{
  if (actx) setcolor(15); else setcolor(8);
  line ((x1+1),y1,(x2-1),y1);
  line (x1,(y1+1),x1,(y2-1));

  if (actx) setcolor(8); else setcolor(15);
  line (x2,(y1+1),x2,(y2-1));
  line ((x1+1),y2,(x2-1),y2);

  setfillstyle(1,7);
  bar ((x1+1),(y1+1),(x2-1),(y2-1));
}

void display_info()
{
  cleardevice();

  ramecek(10,10,630,140,1);

  ramecek(15,15,625,45,0);
  outtextxy_shd(20,20,15,"Clovece, nezlob se!");
  outtextxy_shd(20,30,15,"(c)2001 by Jan Krupa(krupaj@mobilnews.cz)");

  if (DEBUG)
  {
    outtextxy_shd(540,20,4,"DEBUG MODE");
  }

  setcolor(0);
  outtextxy_bold(20,60,"Ovladani:");
  // ------------------------------------------------------------------------------------------"
  outtextxy(20, 70,"Po spusteni hry je na tahu prvni hrac. Kostku muze zastavit stiskem libo-");
  outtextxy(20, 80,"ne klavesy. Pokud neni mozny tah, je nutne zvolit polozku 'Skip turn'. Mezi");
  outtextxy(20, 90,"figurkami se hrac prepina za pomoci kurzorovych sipek. Aktualni figurka");
  outtextxy(20,100,"je zvyraznena svetle zelenou barvou.");

  setcolor(1);
  outtextxy_bold(20,120,"Stiskni cokoli pro start hry...");
  getch();
}

void init_graph()
// init graphics
{
  initgraph(&gd,&gm,GR_PATH);
  errcode=graphresult();
  if (errcode != grOk)
  {
	printf("gr. error\n");
	exit(1);
  }
}

void close_graph()
// close graphics
{
  closegraph();
  clrscr();
  printf("Clovece, nezlob se!\n");
  printf("(c)2001 by Jan Krupa(krupaj@mobilnews.cz).\n\n\n");
}

// *************************************************************************
int check_field(int f1, int * rp1, int * rf1)
// f1 ... field number
// return ... 0==field_is_free, 1==field_is_full
{
  int ix1,ix2;

  for (ix1=0; ix1<MAX_PLAYERS; ix1++)
  {
	for (ix2=0; ix2<P_FIG; ix2++)
	{
	  if (pl[ix1].f[ix2]==f1)
	  {
		*rp1=ix1;
		*rf1=ix2;
		return(1);
	  }
	}
  }

  return(0);
}

int free_home(int p1)
// search for free place in home
// p1 ... player number
// [2do] - use check_field for free field checking(this isn't good)
{
  int ix1;

  for (ix1=0; ix1<P_FIG; ix1++)
  {
	if (!( (pl[p1].f[ix1]>=f.n) && (pl[p1].f[ix1]<(f.n+4)) ))
	{
	  return (ix1);
	}
  }

  return (-1);
}

void draw_skipturn()
{
  if (afig==P_FIG) setcolor(11); else setcolor(8);
  rectangle(20,70,102,88);
  rectangle(19,69,103,89);
}

void circle_k(int x1, int y1, int showx, int colx)
{
  setcolor(0);
  setfillstyle(1,15);
  if (!showx)
  {
    setcolor(colx);
    setfillstyle(1,colx);
  }
  fillellipse(x1,y1,5,5);
}

void draw_kostka_num(int cislo, int showx, int bg)
{
  char c[10];
  int ix1;

  for (ix1=0; ix1<10; ix1++)
  {
    c[ix1]=0;
  }

  switch (cislo)
  {
    case 1 : c[4]=1; break;
    case 2 : c[0]=1; c[8]=1; break;
    case 3 : c[0]=1; c[4]=1; c[8]=1; break;
    case 4 : c[0]=1; c[2]=1; c[6]=1; c[8]=1; break;
    case 5 : c[0]=1; c[2]=1; c[4]=1; c[6]=1; c[8]=1; break;
    case 6 : c[0]=1; c[1]=1; c[2]=1; c[6]=1; c[7]=1; c[8]=1; break;
    case 7 : c[0]=1; c[1]=1; c[2]=1; c[4]=1; c[6]=1; c[7]=1; c[8]=1; break;
    case 8 : c[0]=1; c[1]=1; c[2]=1; c[4]=1; c[5]=1; c[6]=1; c[7]=1; c[8]=1; break;
    case 9 : c[0]=1; c[1]=1; c[2]=1; c[3]=1; c[4]=1; c[5]=1; c[6]=1; c[7]=1; c[8]=1; break;
  }

  for (ix1=0; ix1<10; ix1++)
  {
    if (c[ix1]==1)
    {
      switch(ix1)
      {
        case 0 : circle_k((getmaxx()-80),40,showx,bg); break;
        case 1 : circle_k((getmaxx()-80),60,showx,bg); break;
        case 2 : circle_k((getmaxx()-80),80,showx,bg); break;

        case 3 : circle_k((getmaxx()-60),40,showx,bg); break;
        case 4 : circle_k((getmaxx()-60),60,showx,bg); break;
        case 5 : circle_k((getmaxx()-60),80,showx,bg); break;

        case 6 : circle_k((getmaxx()-40),40,showx,bg); break;
        case 7 : circle_k((getmaxx()-40),60,showx,bg); break;
        case 8 : circle_k((getmaxx()-40),80,showx,bg); break;
      }
    }
  }
}

int hod_kostkou()
// generate random number from players input
{
  int ix1;
  char chx;
  char sx1[20];

  setfillstyle(1,15);
  bar(getmaxx()-110,10,getmaxx()-10,110);
  setfillstyle(1,pl[apl].c);
  bar(getmaxx()-100,20,getmaxx()-20,100);

  ix1=1;
  while (!kbhit())
  {
        draw_kostka_num(ix1,0,pl[apl].c);

	ix1=random(6)+1;

        draw_kostka_num(ix1,1,pl[apl].c);
	delay(50);
  }
  chx=getch();

  // If debug mode is on - return number, you pressed
  if (DEBUG)
  {
    if ( (chx>=48) && (chx<=57) )
    {
      ix1=(chx-48);
    }
  }

  setfillstyle(1,0);
  bar(getmaxx()-110,10,getmaxx()-10,110);
  setfillstyle(1,pl[apl].c);
  bar(getmaxx()-100,20,getmaxx()-20,100);

  draw_kostka_num(ix1,1,pl[apl].c);

  return (ix1);
}

void next_pl()
// it's next players turn
{
  int ix1,ix2;

  ix1=apl;
  ix2=afig;
  apl++;
  if (apl>=MAX_PLAYERS) apl=0;

  // If debug mode is on - set player to 0(only)
  if (DEBUG)
  {
    if (apl>=2) apl=0;
  }

  afig=0;

  if (ix2<P_FIG) draw_field2(pl[ix1].f[ix2],ix1);
  draw_field2(pl[apl].f[afig],apl);
  draw_skipturn();
  kostka=hod_kostkou();
}

void main()
{
  int konec=1,afigx;
  int i1,i2,i3,i4,i5,i6,i7;
  char ch;

  randomize();
  init_graph();
  display_info();

	load_pl_field();
	init_players();
	redraw_field();

	kostka=hod_kostkou();

	while(konec)
	{
          // If debug mode is on - show some info
          if (DEBUG)
          {
            gotoxy (1,1); printf("  DEBUG MODE         ");
            gotoxy (1,2); printf("  kostka==%i, fig==%i  ",kostka,afig);
          }

	  afigx=afig;
	  ch=getch();
	  switch (ch)
	  {
		case 27 : konec=0; break;
		case 13 : i3=1;
				  // skip turn
				  if ( (afig==P_FIG) && (i3) )
				  {
					i3=0;
					next_pl();
				  }

				  // normal move
				  if ( (pl[apl].f[afig]<f.n) && (i3) )
				  {
					i3=0;
					i2=pl[apl].f[afig];
					for (i1=0; i1<kostka; i1++)
					{
					  if (i2!=f.fh[apl])
					  {
						i2++;
						if (i2==f.n) i2=0;
					  }
					  else
					  {
						i2=f.n+P_FIG;
					  }
					}
					if (i2<(f.n+8))
					{

					  i4=check_field(i2,&i5,&i6);
					  if ( (i4==0) || ((i4!=0) && (i5!=apl)) )
					  {
						if (i4!=0)
						{
						  pl[i5].f[i6]=free_home(i5)+f.n;
						  draw_field2(i2,(-1));
						  draw_field2(pl[i5].f[i6],i5);
						}

						i7=pl[apl].f[afig];
						pl[apl].f[afig]=i2;
						draw_field2(i7,apl);
						draw_field2(pl[apl].f[afig],apl);
						if (kostka==6) kostka=hod_kostkou();
								  else next_pl();
					  }
					}
					else
					{
                                          if ( (i2>=(f.n+4)) && (i2<(f.n+8)) )
                                          {
                                            i7=pl[apl].f[afig];
					    pl[apl].f[afig]=i2;
  				            draw_field2(i7,apl);
					    draw_field2(pl[apl].f[afig],apl);
  					    if (kostka==6) kostka=hod_kostkou();
							   else next_pl();
                                          }
					}
				  }

				  // nasazovani
				  if ( (pl[apl].f[afig]>=f.n) && (pl[apl].f[afig]<(f.n+4))
					&& (kostka==6) && (i3) )
				  {
					i3=0;

					i4=check_field(f.fn[apl],&i5,&i6);
					if ( (i4==0) || ((i4!=0) && (i5!=apl)) )
					{
					  if (i4!=0)
					  {
						pl[i5].f[i6]=free_home(i5)+f.n;
						draw_field2(f.fn[apl],(-1));
						draw_field2(pl[i5].f[i6],i5);
					  }

					  i1=pl[apl].f[afig];
					  pl[apl].f[afig]=f.fn[apl];

					  draw_field2(i1,apl);
					  draw_field2(pl[apl].f[afig],apl);
					  kostka=hod_kostkou();
					}
				  }

				  // domek
                                  // [2do] - check if there isn't figurka
				  if ( (pl[apl].f[afig]>=(f.n+4)) && (i3) )
				  {
					i3=0;
					i2=pl[apl].f[afig];
					for (i1=0; i1<kostka; i1++)
					{
					  pl[apl].f[afig]++;
					}

					if (pl[apl].f[afig]<(f.n+8))
					{
					  draw_field2(i2,apl);
					  draw_field2(pl[apl].f[afig],apl);
					  if (kostka==6) kostka=hod_kostkou();
								else next_pl();
					}
					else
					{
					  pl[apl].f[afig]=i2;
					}
				  }

				  break;
		 case 0 : ch=getch();
				  switch (ch)
				  {
					// left
					case 75 : afig--; break;
					// right
					case 77 : afig++; break;
				  }
				  break;
	  }
	  // (afig==P_FIG) -> skip turn
	  if (afig<0) afig=P_FIG;
	  if (afig>P_FIG) afig=0;

	  if (afig!=afigx)
	  {
		if (afigx!=P_FIG) draw_field2(pl[apl].f[afigx],apl);
		if (afig!=P_FIG) draw_field2(pl[apl].f[afig],apl);

                draw_skipturn();
		/*if (afig==P_FIG) setcolor(0); else setcolor(8);
		rectangle(20,70,102,88);
		rectangle(19,69,103,89);*/
	  }
	}

  close_graph();
}
